package RFC::Header;
#$Id: Header.pm,v 1.114 2019/01/09 10:17:28 sqko Exp $
$ENV{'PATH'} = '/bin:/usr/bin:/usr/local/bin';
use strict;
use warnings;
use Fcntl qw(:DEFAULT :flock);
use POSIX;

################################################################
#
#  Package RFC::Header
#
# This module contains site wide file locations and similar 
# global variables used by the other modules supplied as part
# of RFCcontrol.
#
################################################################

BEGIN {
    use Exporter ();
    our ($VERSION, @ISA, @EXPORT, @EXPORT_OK, %EXPORT_TAGS);
    $VERSION = '6.0.6';
    %EXPORT_TAGS = (
        'standard'=>[qw/$homedir $publicdir $libdir $htmldir $devicelock $user_exec_dir $programlock $userdir $configfile $configlock $spline $COPYRIGHT/]
                    );
    Exporter::export_ok_tags('standard');
    Exporter::export_tags('standard');
    @ISA = qw(Exporter);
}

my @lt = localtime();
my $year = $lt[5]+1900;
my $WEB = '/home/http/html/';

#### Global file locations ####
our $homedir = '/home/celltest/';
our $publicdir = $WEB;
our $userdir = '/home/';
our $libdir = '/usr/local/bin/celltest/';
our $htmldir = $WEB.'celltest/';
our $configfile = $homedir.'/conf/celltest_global.conf';
our $uicfg = $homedir.'/conf/UI.cfg';
our $configlock = $homedir.'/conf/conf.lock';
our $user_exec_dir = $libdir.'user_exec/';

### Program semafore files ###
our $programlock = '/home/celltest/userprogram.lock';
our $spline = '/usr/local/bin/splineinterpol';

### Header strings ###
our $COPYYEAR = '2011 - '.$year;
our $IMPLEMENTERS = 'S&oslash;ren Koch, Martin Nielsen';
our $COPYRIGHT = 'DTU Energy';
our $DESIGNERS = 'S&oslash;ren Koch';
our $TESTERS = 'Johan Hjelm, Anne Hauc, Christopher Graves and Xiufu Sun';


return 1;
