#!/usr/bin/perl -T
# $Id: setup_program.cgi,v 1.36 2018/09/20 11:13:00 sqko Exp $
############################################################
############################################################
###                                                      ###
###   Originally designed by Soeren Koch.                ###
###                                                      ###
###   Impelemented by Soeren Koch                        ###
###                                                      ###
###   Copyright by Soeren Koch January 20011             ###
###                                                      ###
############################################################
############################################################

use strict;
use warnings;
use CGI qw(:standard :netscape);
use RFC::Main;
use RFC::Rig;
use RFC::RFCCGI qw(:cgi :html);
use RFC::Header;
use SemaforeFile;

my $acmode = get_cv('global','access_mode');
$acmode = 'celltest' unless ($acmode);

my $r = param('rig');
unless ($r)
{
    print header();
    print "No rig specified!\n";
    exit;
}
my $rig = RFC::Rig->new($r);

my $file = SemaforeFile->new($RFC::Header::publicdir.'rig'.$rig->name.'/custom.conf');
my $comploc = get_cv('impedance','standard_compensation_files');
my @compfiles;
if ($comploc)
{
    my $ending = '\.i2b';
    if ($comploc =~/(\w*\*\.\w+)$/)
    {
	$ending = $1;
	if ($ending =~ /^\*\./)
	{
	    $ending =~ s/^\*/\\/;
	}
	$comploc =~ s/\w*\*\.i2b$//;
    }
    opendir(DIR,$comploc) or die "Cant open dir $comploc $!";
    @compfiles = grep {/$ending/o && -e "$comploc/$_"} readdir(DIR);
    closedir DIR;
}
else
{
    my $dir = $RFC::Header::publicdir.'rig'.$rig->name.'/imp_comp/';
    opendir(DIR,$dir) or die "Cant open dir $dir $!";
    @compfiles = grep { !/^\./ && -e "$dir/$_"} readdir(DIR);
    closedir DIR;
}

my $usermode = user_auth($acmode,'c');
$usermode = 1 if (RFC::RFCCGI::rig_mode());

my $isused = 0;
my $cmd = '/bin/ps -efl | /bin/grep custom_prog.pl | /bin/grep -P "rig'.$rig->name.'\\b"';
my $str = `$cmd`;
my @list = ();
@list = split(/\n/,$str) if ($str);
foreach (@list)
{
    $isused = 1 if /celltest/;
}

for (my $x = 0; $x < @compfiles; $x++)
{
    $compfiles[$x] =~ /([\w\.]+)$/;
    $compfiles[$x] = $1;
}
if (!defined(param))
{
    &print_header("Please log in to the $name");
    print '<center>';
    RFCCGI::login();
    print '</center>';
    &print_end;
}
else
{
    #### husk at aendre accessparameter til det relevante for scriptet!! ####
    if ((login_ok()) && $usermode && RFC::RFCCGI::rig_auth())
    { 
	print_header("Setup program for $rig");
	&top_nav_bar_start;
        if (user_auth($acmode,'m'))
        {
            &top_nav_bar_button('manual_edit_prog.cgi','','','Setup flow variation','s0','rig,'.$rig->name.',1','file,flowvar,1');
            &top_nav_bar_button('manual_edit_prog.cgi','','','Setup impedance program','s0','rig,'.$rig->name.',1','file,impedance,1');
        }
        else
        {
            &top_no_button;
	    &top_no_button;
        }
	if (!param('action') || get_CGI_value_clean('action') !~ /^Load/)
	{
	    &top_nav_bar_button('','','action','Load old program','s5','rig,'.$rig->name.',1');
	}
	else
	{
	    &top_no_button;
	}
	&tab_newrow;
	if (get_CGI_value_clean('action'))
	{
	    &top_no_button;
	}
	else
	{
	    &js_back();
	    &top_js_return('#006600','white');
	}
	if (!param('action') || (get_CGI_value_clean('action') !~ /Run\sprogram/))
	{
	    &top_nav_bar_button('','','action','Clear program','s0','rig,'.$rig->name.',1');
	    &top_nav_bar_button('','','action','Delete last line','s1','rig,'.$rig->name.',1');
	    &top_nav_bar_button('manual_edit_prog.cgi','','','Manual edit program','s4','rig,'.$rig->name.',1');
	}
	else
	{
	    &top_no_button;
	    &top_no_button;
	    &top_no_button;
	}
	&top_nav_bar_button('rig_main.cgi','','','To rig'.$rig->name.' main page','s3','rig,'.$rig->name.',1');
	&end_top_bar;
        param(-name=>'action',-value=>'')  unless (defined(param('action')));
	$_ = param('action');
      CASE:
	{
	    ### Insert case statements ###
	    ### /^save$/ and do {&save; last CASE;};
	    /^wait_input/ and do {&wait_input; &main_page; last CASE;};
	    /^Clear\s+program$/ and do {&clear_prog; last CASE;};
	    /^mleak$/ and do {&add_cmd('m_leak'); &main_page; last CASE;};
	    /^measure$/ and do {&add_cmd('measure'); &main_page; last CASE;};
	    /^iv$/ and do {&add_cmd('iv'); &add_cmd('wait = '.&get_CGI_value_clean('wait')); &main_page; last CASE;};
	    /^ivwait$/ and do {&add_cmd('ivwait'); &main_page; last CASE;};
	    /^killiv$/ and do {&add_cmd('killiv'); &main_page; last CASE;};
	    /^flowvar$/ and do {&add_cmd('#FLOWVAR'); &main_page; last CASE;};
	    /^OCV$/ and do {&add_cmd('current = OCV '.get_CGI_value_clean('device')); &main_page; last CASE;};
	    /^current$/ and do {&add_cmd('current = '.&get_CGI_value_clean('current').' '.get_CGI_value_clean('device')); &main_page; last CASE;};
	    /^wait$/ and do {&add_cmd('wait = '.&get_CGI_value_clean('wait')); &main_page; last CASE;};
	    /^set_gas$/ and do {&add_cmd('gas:'. &get_CGI_value_clean('gas') . ' = ' . &get_CGI_value_clean('flow')); &main_page; last CASE;};
	    /^set_pressure$/ and do {&add_cmd('pressure:'. &get_CGI_value_clean('gas') . ' = ' . &get_CGI_value_clean('flow')); &main_page; last CASE;};
	    /^set_pid$/ and do {&add_cmd('PID:'. &get_CGI_value_clean('pid') . ' = ' . &get_CGI_value_clean('setpoint')); &main_page; last CASE;};
	    /^std_imp$/ and do {&imp(0); &main_page; last CASE;};
	    /^current_imp$/ and do {&cimp(); &main_page; last CASE;};
	    /^potsweep$/ and do {&cimp('potsweep'); &main_page; last CASE;};
	    /^chrono$/ and do {&cimp('chrono'); &main_page; last CASE;};
	    /^single_imp$/ and do {&imp(1); &main_page; last CASE;};
	    /^socket_call$/ and do {&socket_call; &main_page; last CASE;};
	    /^temp$/ and do {&add_cmd('ramp = '.&get_CGI_value_clean('ramp').' '.get_CGI_value_clean('device')); &add_cmd('temp = '.&get_CGI_value_clean('temp').' '.get_CGI_value_clean('device')); &main_page; last CASE;};
	    /^adjust$/ and do {&add_cmd('addjust_temp '.&get_CGI_value_clean('temp').' '. &get_CGI_value_clean('offset').' '.get_CGI_value_clean('device')); &main_page; last CASE;};
	    /^text$/ and do {&add_cmd('text = '.&get_CGI_value_clean('text')); &main_page; last CASE;};
	    /^Delete\s+last\s+line$/ and do {&dellast; &main_page; last CASE;};
	    /^Run\sprogram$/ and do {&run_prog; last CASE;};
	    /^Stop\sprogram$/ and do {&stop_prog; last CASE;};
	    /^Load\sold/ and do {&load_main; last CASE;};
	    /^select_prog$/ and do {&load; &main_page; last CASE;};
	    /^gas_multiplex$/ and do {&multiplex; &main_page; last CASE;};
	    /^water_enable/ and do {&add_cmd('water:'. &get_CGI_value_clean('wname') . ' = ' . &get_CGI_value_clean('status')); &main_page; last CASE;};
	    /^relay_enable/ and do {&add_cmd('relay:'. &get_CGI_value_clean('rname') . ' = ' . &get_CGI_value_clean('status')); &main_page; last CASE;};
	    /^exec/ and do {&add_cmd('exec:'.&get_CGI_value('program').' '.&get_CGI_value('args')); &main_page; last CASE;};
	    ### Default response ####
    	    &main_page;
	}	
	print end_html;
    }
    else 
    {
	&not_auth;
    }
}
    
exit;

sub wait_input
{
    my $devname = &get_CGI_value_clean('rname');
    return unless ($devname);
    my $maxtime = &get_CGI_value_clean('maxtime');
    if ($maxtime)
    {
	&add_cmd('wait_for_input: '.$devname.' '.$maxtime);
    }
    else
    {
	&add_cmd('wait_for_input: '.$devname);
    }
}

sub load_main
{
    my $test = $rig->session;
    $test = &get_CGI_value_clean('test') if (&get_CGI_value('test'));
    my $cmd = '/bin/ls -1 '.$RFC::Header::publicdir.'rig'.$rig->name.'/'.$rig->name.'test'.$test.'/program_*.txt';
    my @list = `$cmd`;
    print '<center>';
    print '<table border=0 cellspacing=5 cellpadding=0 style="width:100%"><tr>';
    print '<td width="20%"></td>';
    print '<td width="10%"></td>';
    print '<td width="40%"></td>';
    print '<td width="10%"></td>';
    print '<td width="20%"></td>';
    print '</tr>';
    print '<tr><td height=20></td></tr>';
    print '<tr><td colspan=5 class=heading> Load old program from ',$rig->name,' test ',$test,' </td></tr>';
    print '<tr><td height=20></td></tr>';
    print start_form(-class=>'form',-name=>'sofc');
    &print_hidden_rig();
    &action('select_prog');
    print '<tr><td></td><th> Select program: </th><td>';
    print popup_menu(-name=>'file',-values=>[@list],-class=>'textfield');
    print '</td><td>';
    &menu_button('','Select program','s0');
    print '</td></tr>';
    my @tests = ();
    for (my $x = 1; $x <= $rig->session; $x++)
    {
	push @tests,$x;
    }
    print '<tr><td></td><th> Select other test: </th><td>';
    print popup_menu(-name=>'test',-values=>[@tests],-default=>$test,-class=>'textfield',-onchange=>'select_session()');
    print '</td><td>';
    print '</td></tr>';
    print end_form();
    print '</td></tr></table></center>';

    print <<END;

<script language="javascript">

function select_session()
{
    document.sofc.file.disabled = true;
    document.sofc.test.disabled = true;
    var session = document.sofc.test[document.sofc.test.selectedIndex].value;
    run_ajax('rig_ajax_run.cgi','&action=get_programs_test&session='+session,set_progs);
}

function set_progs(res)
{
    var arr = res.split("\\n");
    document.sofc.file.length = 0;
    for (x = 0; x < arr.length; x++)
    {
	var optn = document.createElement("OPTION");
	optn.value = arr[x];
	optn.text = arr[x];
	document.sofc.file.options.add(optn);
    }
    document.sofc.file.disabled = false;
    document.sofc.test.disabled = false;
}



</script>

END

}

sub load
{
    eval
    {
	my $f = &get_CGI_value('file');
	$f =~ /([\w\-\.\/\:]+)/;
	$f = $1;
	if ($f)
	{
	    my $old = SemaforeFile->new($f);
	    my @lines = $old->readlines();
	    $file->writeline(@lines);
	}
	else
	{
	    &print_error('No filename specified, operation aborted!');
	}
    };
    if ($@)
    {
	&errorlog($@);
	&print_error();
    }
}


sub stop_prog
{
    eval
    {    
	my $res = RFC::Main::CGI_client($rig->name,"stop_custom"); 
	my $user = get_user();
	$rig->proglog("Program terminated",$user);
	print center(h1({-class=>'heading'},"Program for rig ".$rig->name." terminated by user $user"));
    };
    if ($@)
    {
	&errorlog($@);
	&print_error();
    }

}

sub run_prog
{
    my $test = $rig->session;
    eval
    {
	my @lines = ();
	$file->lock_ex;
	$file->open_read;
	while (my $st = $file->readline)
	{
	    push @lines,$st unless ($st =~ /^\#/);
	    if ($st =~ /^\#FLOWVAR/)
	    {
		$st = '#'.$st;
		#### get all flowvar ####
		my $f = $RFC::Header::publicdir.'rig'.$rig->name.'/flowvar.conf';
		open FIN,'<',$f or die "Could not open file $f for reading: $!";
		while (<FIN>)
		{
		    push @lines , $_ unless ($_ =~ /^\#/);
		}
		close FIN;
	    }
	    if ($st =~ /^\#STDIMP/)
	    {
		$st = '#'.$st;
		$st =~ /IP:([\d\.]+)/;
		my $ip = $1;
		$st =~ /PORT:(\d+)/;
		my $port = $1;
		$st =~ /USER:(\w+)/;
		my $user = $1;
		$st =~ /SESSION:(\d+)/;
		my $session = $1;
		$st =~ /BOX:(\d+)/;
		my $box = $1;
		$st =~ /COMP:([\w\.\/]+)/;
		my $comp = $1;
		$comp = 'short.i2b' if ($comp eq 'DEFAULT');
		my $impstr = "impedance $ip:$port $session $user comp:$comp";
		my $cimpstr = "current_impedance $ip:$port $session $user comp:";
		my $ip_user = "$ip:$port $user";
		my $imp_uncomp = "impedance $ip:$port $session $user";
		my $f = $RFC::Header::publicdir.'rig'.$rig->name.'/impedance.conf';
		open IIN,'<',$f or die "Could not open file $f for reading: $!";
		while (my $s = <IIN>)
		{
		    $s =~ s/ADDR/$box/;
		    $s =~ s/impedance CONF/$impstr/;
		    $s =~ s/current_impedance CONF/$cimpstr/;
		    $s =~ s/impedance UNCOMP/$imp_uncomp/;
		    $s =~ s/IP_USER/$ip_user/;
		    push @lines , $s unless ($s =~ /^\#/);
		}
		close IIN;
	    }
	}
	$file->close;
	$file->unlock;
	##### Create new unique file name for program name ####
	my $dat = `date +"%Y:%m:%d:%H:%M"`;
	$dat =~ /([\d\:]*)/;
	$dat = $1;
	my $file1 = SemaforeFile->new($RFC::Header::publicdir.'rig'.$rig->name.'/'.$rig->name.'test'.$rig->session.'/program_'.$dat.'.txt');
	$file1->writeline(@lines);
	my $user = &get_user();
	my $res = RFC::Main::CGI_client($rig->name,'custom',$file1->filename,$user); 
	if ($res)
	{
	    $rig->proglog("Program ".$file1->filename." activated by",$user);
	    print center(h1({-class=>'heading'},"Program ".$file1->filename." activated for rig ".$rig->name));
	    $file->writeline();
	}
    };
    if ($@)
    {
	&errorlog($@);
	&print_error();
    }
}


sub main_page
{
    if (!$isused)
    {
	&setup_main;
    }
    else
    {
	my $f = '';
	print center(h1({-class=>'heading'},"Program is currently running!"));
        my $cmd = '/bin/ps -efl | /bin/grep custom_prog.pl | /bin/grep -P "rig'.$rig->name.'\\b"';
        my $string = `$cmd`;
        my @list = ();
        @list = split(/\n/,$str) if ($str);
	for my $str (@list)
	{
	    if ($str =~ /(\/home\/http\/html\/[\w\/\:\.]+)/)
	    {
		$f = SemaforeFile->new($1);
	    }    
	}
	my $str = '';
	if ($f && -e $f->filename)
	{
	    $str = join("\n",$f->readlines());
	}
	print '<center>';
	print '<table border=0 cellspacing=5 cellpadding=0 style="width:100%"><tr>';
	print '<td width="10%"></td>';
	print '<td width="40%"></td>';
	print '<td width="40%"></td>';
	print '<td width="10%"></td>';
	print '</tr>';
	print '<tr><td colspan=4 class="heading">';
	print "Setup sequential program for rig ".$rig->name;
	print '</td></tr>';
	print '<tr><td></td><td valign=top>';
	print 'Current program:';
	print textarea(-name=>'test',-value=>$str,-class=>'textfield',-rows=>'20');
	print '</td><td>';
	print start_form(-class=>'form',-onsubmit=>'return checkinput()');
	&print_hidden_rig();
	&menu_button('action','Stop program','s0');
	print end_form();
	print <<END;

<script lanuage=javascript>
function checkinput() {
    return confirm('Terminate running program?');
}
</script>

END
    }
}

sub setup_main
{
    my $server = $rig->get_cv('impedance','server');
    my $port = $rig->get_cv('impedance','port');
    my $isuser = $rig->get_cv('impedance','user');
    my $session = $rig->get_cv('impedance','session');
    my $comp = $rig->get_cv('impedance','compensation');
    $comp = 'DEFAULT' unless ($comp);
    $server = '127.0.0.1' unless ($server);
    $port = '4040' unless ($port);
    $isuser = get_user() unless ($isuser);
    $session = 1 unless ($session);

    $str = '';
    $str = join("\n",$file->readlines()) if (-e $file->filename);
    print '<center>';
    print '<table border=0 cellspacing=5 cellpadding=5 style="width:100%"><tr>';
    print '<td width="1%"></td>';
    print '<td width="28%"></td>';
    print '<td width="70%"></td>';
    print '<td width="1%"></td>';
    print '</tr>';
    print '<tr><td colspan=4 class="heading">';
    print "Setup sequential program for rig ".$rig->name;
    print '</td></tr>';
    print '<tr><td></td><td valign=top>';
    print start_form(-class=>'form');
    &print_hidden_rig();
    print 'Current program (Note do not edit here!):';
    print textarea(-name=>'test',-value=>$str,-class=>'textfield',-rows=>'35',-force=>'1',-wrap=>'OFF',-onfocus=>'this.blur()');
    &menu_button('action','Run program','s2');
    print end_form();
    print '</td><td valign=top>';
    print '<table border=0 cellspacing=5 cellpadding=0 style="width:100%">';
    print '<tr height=0px>';
    print '<td width=35%></td>';
    print '<td width=15%></td>';
    print '<td width=10%></td>';
    print '<td width=10%></td>';
    print '<td width=10%></td>';
    print '<td width=10%></td>';
    print '<td width=10%></td>';
    print '</tr>';
    print start_form(-class=>'form');
    print '<tr><td>';
    &print_hidden_rig();
    &action('measure');
    &menu_button('','Log all channels','setup0');
    print '</td></tr>';
    print end_form;
    print start_form();
    print '<tr><td>';
    &print_hidden_rig();
    &action('mleak');
    &menu_button('','Add leak measurement','setup1');
    print '</td></tr>';
    print end_form;
    print start_form(-class=>'form');
    print '<tr><td>';
    &print_hidden_rig();
    &action('wait');
    &menu_button('','Wait for','setup2');
    print '</td><td>';
    print textfield(-name=>'wait',-value=>'1',-force=>'1',-class=>'textfield_setup');
    print '</td><th> min.';
    print  '<tr><td colspan=7><hr></td></tr>';
    print '</th></tr>';
    print end_form;
    print start_form(-class=>'form');
    print '<tr><td>';
    &print_hidden_rig();
    &action('flowvar');
    &menu_button('','Add Flow variation','s2');
    print '</td></tr>';
    print end_form;
    print  '<tr><td colspan=7><hr></td></tr>';
    print start_form(-class=>'form');
    &print_hidden_rig();
    &action('std_imp');
    print '<tr><td rowspan=2>';
    &menu_button('','Impedance program','s2');
    print '</td><th> IP adress: </th><td>';
    print textfield(-name=>'ip',-value=>$server,-class=>'textfield_setup');
    print '</td><th> port: </th><td>';
    print textfield(-name=>'port',-value=>$port,-class=>'textfield_setup');
    print '</td><th> session: </th><td>';
    print textfield(-name=>'session',-value=>$session,-class=>'textfield_setup');
    print '</td></tr><tr><th> User: </th><td>';
    print textfield(-name=>'riguser',-value=>$isuser,-class=>'textfield_setup');
    print '</td><th> compfile: </th><td colspan=3>';
    print popup_menu(-name=>'comp',-values=>['DEFAULT',@compfiles],-class=>'textfield',-default=>$comp);
    print '</td></tr>';
    print end_form;
    if ($rig->list_devices_control('PSU'))
    {
	print  '<tr><td colspan=7><hr></td></tr>';
	print start_form(-class=>'form');
	print '<tr><td>';
	&print_hidden_rig();
	&action('OCV');
	&menu_button('','Set OCV','s3');
	if ($rig->list_devices_control('PSU') > 1)
	{
	    print '</td><td>';
	    print popup_menu(-name=>'device',-values=>[$rig->list_devices_control('PSU')],-class=>'textfield');
	}
	else
	{
	    print hidden(-name=>'device',-value=>($rig->list_devices_control('PSU'))[0],-force=>1);
	}
	print '</td></tr>';
	print end_form;
	print start_form(-class=>'form');
	print '<tr><td>';
	&print_hidden_rig();
	&action('current');
	&menu_button('','Set current to','setup3');
	print '</td><td>';
	print textfield(-name=>'current',-value=>'0',-force=>'1',-class=>'textfield_setup');
	print '</td><th> A';
	if ($rig->list_devices_control('PSU') > 1)
	{
	    print ' for device </td><td>';
	    print popup_menu(-name=>'device',-values=>[$rig->list_devices_control('PSU')],-class=>'textfield');
	}
	else
	{
	    print hidden(-name=>'device',-value=>($rig->list_devices_control('PSU'))[0],-force=>1);
	}
	print '</th></tr>';
	print end_form;
	print start_form(-class=>'form');
	print '<tr><td>';
	&print_hidden_rig();
	&action('ivwait');
	&menu_button('','Start i-V curve and wait till finish','setup4');
	print '</td></tr>';
	print end_form;
	print start_form(-class=>'form');
	print '<tr><td>';
	&print_hidden_rig();
	&action('iv');
	&menu_button('','Start i-V curve','setup5');
	print '</td><th>and Wait for';
	print '</th><td>';
	print textfield(-name=>'wait',-value=>'30',-force=>'1',-class=>'textfield_setup');
	print '</td><th> min.';
	print '</th></tr>';
	print end_form;
	print start_form(-class=>'form');
	print '<tr><td>';
	&print_hidden_rig();
	&action('killiv');
	&menu_button('','Kill running i-V curve','s0');
	print '</td></tr>';
	print end_form;
    }
    print  '<tr><td colspan=7><hr></td></tr>';
    print start_form(-class=>'form');
    &print_hidden_rig();
    &action('single_imp');
    print '<tr><td rowspan=2>';
    &menu_button('','Single impedance ','setup6');
    print '</td><th> IP adress: </th><td>';
    print textfield(-name=>'ip',-value=>$server,-class=>'textfield_setup');
    print '</td><th> port: </th><td>';
    print textfield(-name=>'port',-value=>$port,-class=>'textfield_setup');
    print '</td><th> session: </th><td>';
    print textfield(-name=>'session',-value=>$session,-class=>'textfield_setup');
    print '</td></tr><tr><th> User: </th><td>';
    print textfield(-name=>'riguser',-value=>$isuser,-class=>'textfield_setup');
    print '</td><th> compfile: </th><td colspan=3>';
    print popup_menu(-name=>'comp',-values=>[@compfiles],-class=>'textfield',-default=>$comp);
    print '</td></tr>';
    print end_form;
    if ($rig->list_devices_control('PSU'))
    {
	print  '<tr><td colspan=7><hr></td></tr>';
	print start_form(-class=>'form');
	print '<tr><td rowspan=2>';
	&print_hidden_rig();
	&action('current_imp');
	&menu_button('','Impedance under current','setup7');
	print '</td><th> IP adress: </th><td>';
	print textfield(-name=>'ip',-value=>$server,-class=>'textfield_setup');
	print '</td><th> port: </th><td>';
	print textfield(-name=>'port',-value=>$port,-class=>'textfield_setup');
	print '</td></tr><tr><th> User: </th><td>';
	print textfield(-name=>'riguser',-value=>$isuser,-class=>'textfield_setup');
	print '</td><th> session: </th><td>';
	print textfield(-name=>'session',-value=>$session,-class=>'textfield_setup');
	print '</td></tr>';
	print end_form;
    }
    else
    {
	print  '<tr><td colspan=7><hr></td></tr>';
	print start_form(-class=>'form');
	print '<tr><td rowspan=2>';
	&print_hidden_rig();
	&action('potsweep');
	&menu_button('','Potential weep','setup7');
	print '</td><th> IP adress: </th><td>';
	print textfield(-name=>'ip',-value=>$server,-class=>'textfield_setup');
	print '</td><th> port: </th><td>';
	print textfield(-name=>'port',-value=>$port,-class=>'textfield_setup');
	print '</td></tr><tr><th> User: </th><td>';
	print textfield(-name=>'riguser',-value=>$isuser,-class=>'textfield_setup');
	print '</td><th> session: </th><td>';
	print textfield(-name=>'session',-value=>$session,-class=>'textfield_setup');
	print '</td></tr>';
	print end_form;
	print  '<tr><td colspan=7><hr></td></tr>';
	print start_form(-class=>'form');
	print '<tr><td rowspan=2>';
	&print_hidden_rig();
	&action('chrono');
	&menu_button('','Chrono potentiometry/amperometry','setup7');
	print '</td><th> IP adress: </th><td>';
	print textfield(-name=>'ip',-value=>$server,-class=>'textfield_setup');
	print '</td><th> port: </th><td>';
	print textfield(-name=>'port',-value=>$port,-class=>'textfield_setup');
	print '</td></tr><tr><th> User: </th><td>';
	print textfield(-name=>'riguser',-value=>$isuser,-class=>'textfield_setup');
	print '</td><th> session: </th><td>';
	print textfield(-name=>'session',-value=>$session,-class=>'textfield_setup');
	print '</td></tr>';
	print end_form;
    }
    print  '<tr><td colspan=7><hr></td></tr>';
    print start_form(-class=>'form');
    print '<tr><td rowspan=2>';
    &print_hidden_rig();
    &action('socket_call');
    &menu_button('','TCP/IP socket call','setup5');
    print '</td><th> IP adress: </th><td>';
    print textfield(-name=>'ip',-value=>$server,-class=>'textfield_setup');
    print '</td><th> port: </th><td>';
    print textfield(-name=>'port',-value=>$port,-class=>'textfield_setup');
    print '</td></tr><tr><th> arguments (separate by ,): </th><td colspan=5>';
    print textfield(-name=>'args',-value=>'',-class=>'textfield');
    print '</td></tr>';
    print end_form;
    print  '<tr><td colspan=7><hr></td></tr>';
    if ($rig->list_devices_control('tempcontrol'))
    {
	print start_form(-class=>'form');
	print '<tr><td>';
	&print_hidden_rig();
	&action('temp');
	&menu_button('','Set temperature to','setup8');
	print '</td><td>';
	print textfield(-name=>'temp',-value=>'750',-class=>'textfield_setup');
	print '</td><th> C with </th><td>';
	print textfield(-name=>'ramp',-value=>'60',-class=>'textfield_setup');
	print '</td><th> C/hour';
	if($rig->list_devices_control('tempcontrol') > 1)
	{
	    print '</th><th>for device </th><th>';
	    print popup_menu(-name=>'device',-values=>[$rig->list_devices_control('tempcontrol')],-class=>'textfield');	
	}
	else
	{
	    print hidden(-name=>'device',-value=>($rig->list_devices_control('tempcontrol'))[0],-force=>1);	
	}
	print '</th></tr>';
	print end_form;
	print start_form(-class=>'form');
	print '<tr><td>';
	&print_hidden_rig();
	&action('adjust');
	&menu_button('','Adjust temperature to','setup9');
	print '</td><td>';
	print textfield(-name=>'temp',-value=>'750',-class=>'textfield_setup');
	print '</td><th> C with max </th><td>';
	print textfield(-name=>'offset',-value=>'10',-class=>'textfield_setup',-force=>1);
	print '</td><th> C in offset (waits 3 hours)';
	if($rig->list_devices_control('tempcontrol') > 1)
	{
	    print '</th><th>for device </th><th>';
	    print popup_menu(-name=>'device',-values=>[$rig->list_devices_control('tempcontrol')],-class=>'textfield');	
	}
	else
	{
	    print hidden(-name=>'device',-value=>($rig->list_devices_control('tempcontrol'))[0],-force=>1);	
	}
	print '</th></tr>';
	print end_form;
    }
#    print  '<tr><td colspan=7><hr></td></tr>';
    if ($rig->list_devices_control('gas'))
    {
	my @gasses = ();
	my @pressures = ();
	foreach my $n ($rig->list_devices_control("gas"))
	{
	    my $dev = $rig->get_device('gas',$n);
	    next unless ($dev && !$dev->readonly && $dev->mode =~ /auto/i);
	    if ($dev->is_pressure)
	    {
		push @pressures,$n;
	    }
	    else
	    {
		push @gasses,$n;
	    }
	}
	if (@gasses)
	{
	    print start_form(-class=>'form');
	    print '<tr><td>';
	    &print_hidden_rig();
	    &action('set_gas');
	    &menu_button('','Set gas flow for','setup10');
	    print '</td><td>';
	    print popup_menu(-name=>'gas',-values=>[@gasses],-class=>'textfield');
	    print '</td><th align=center> to </th><td>';
	    print textfield(-name=>'flow',-value=>'0',-force=>'1',-class=>'textfield_setup');
	    print '</td><th> L/hour.';
	    print '</th></tr>';
	    print end_form;
	}
	if (@pressures)
	{
	    print start_form(-class=>'form');
	    print '<tr><td>';
	    &print_hidden_rig();
	    &action('set_pressure');
	    &menu_button('','Set gas pressure for','setup11');
	    print '</td><td>';
	    print popup_menu(-name=>'gas',-values=>[@pressures],-class=>'textfield');
	    print '</td><th align=center> to </th><td>';
	    print textfield(-name=>'flow',-value=>'1',-force=>'1',-class=>'textfield_setup');
	    print '</td><th> barA.';
	    print '</th></tr>';
	    print end_form;
	}	
    }
    if ($rig->list_devices_control('PID'))
    {
	print start_form(-class=>'form');
	print '<tr><td>';
	&print_hidden_rig();
	&action('set_pid');
	&menu_button('','Set setpoint for','setup5');
	my @pids = ();
	foreach my $n ($rig->list_devices("PID"))
	{
	    my $dev = $rig->get_device('PID',$n);
	    next unless ($dev && !$dev->readonly && $dev->mode =~ /auto/i);
	    push @pids,$n;
	}
	print '</td><td>';
	print popup_menu(-name=>'pid',-values=>[@pids],-class=>'textfield');
	print '</td><th align=center> to </th><td>';
	print textfield(-name=>'setpoint',-value=>'0',-force=>'1',-class=>'textfield_setup');
	print '</td><th>';
	print '</th></tr>';
	print end_form;
    }
    my %gass = ();
    my @g = ();
	foreach my $cont ($rig->list_devices('MFC'))
	{
	my $dev = $rig->get_device('MFC',$cont);
	my @gasses = $dev->gasses;
	if (@gasses > 1 && $dev->gas_change() =~ /auto/i)
	{
	    my $d = $dev->multiplexer();
	    $gass{$d->name} = \@gasses;
	    push @g,$d->name;
	}
    }
    unshift @g,'' if (@g > 1);
    if (@g)
    {
	print start_form(-class=>'form',-name=>'gasmultiplex',-onsubmit=>'return check_flow()');
	print '<tr><td>';
	&print_hidden_rig();
	&action('gas_multiplex');
	&menu_button('','Select gas for multiplexer','setup11');
	print '</td><td>';
	print popup_menu(-name=>'controler',-values=>[(@g)],-class=>'textfield',-default=>'',-force=>'1',-onchange=>'set_gasses()');
	print '</td><th align=center> to </th><td>';
	if (@g > 1)
	{
	    print popup_menu(-name=>'gas',-values=>[()],-class=>'textfield');
	}
	else
	{
	    print popup_menu(-name=>'gas',-values=>[('',@{$gass{$g[0]}})],-class=>'textfield');
	}
	print '</td><th align=center>flow </th><td>';
	print textfield(-name=>'flow',-value=>'0',-force=>'1',-class=>'textfield_setup');
	print '</td><th> L/hour.';
	print '</th></tr>';
	print end_form;

	print <<END;

<script lanuage="javascript">

function set_gasses() {
    document.gasmultiplex.gas.options.length = 0;
END

        foreach my $cont_name (@g)
        {
	    my $cont = $rig->get_device('multiplex',$cont_name);
	    next unless ($cont);
	    print '    if (document.gasmultiplex.controler.options[document.gasmultiplex.controler.options.selectedIndex].value == "'.$cont_name.'") {',"\n";
	    print '        document.gasmultiplex.gas.options[0] = new Option("");',"\n";
	    for (my $x = 0; $x < @{$gass{$cont_name}}; $x++)
	    {
		my $y = $x+1;
		print '        document.gasmultiplex.gas.options[',$y,'] = new Option("',${$gass{$cont_name}}[$x],'");',"\n";
	    }
	    print '    }',"\n";
        }
	print <<END;
}

function check_flow() {
    var f = document.gasmultiplex.flow.value;
    if (f > 0)
    {
	return true;
    }
    return confirm("Flow for new gas is 0!\\nIs this intensional?");
}

</script>


END
	

    }

    my %h = ();
    ### Get normal relays ###
#    my $string = $rig->get_cv('main','relay_names');
#    my @d = ();
#    @d = split(/\s*\,\s*/,$string) if ($string);
    my @d = $rig->list_devices_control('relay');
    foreach my $name (@d)
    {
        ### exclude readonly devices ###
        next if ($rig->get_device('relay',$name)->mode =~ /readonly/i);
        $h{$name} = 1;
    }
    ### Get water bubler relays ###
    @d = $rig->list_devices_control('water');
    foreach my $name (@d) 
    {
        ### exclude readonly devices ###
        my $dev = $rig->get_device('water',$name);
#        next if ($dev->mode =~ /readonly/i);
        $h{$dev->control_device->name} = 1;
    }
    @g = ();
    foreach my $key (keys %h)
    {
        push @g,$key;
    }
    unshift @g,'' if (@g > 1);
    print start_form(-class=>'form',-name=>'relay');
    if (@g)
    {
	print '<tr><td>';
	&print_hidden_rig();
	&action('relay_enabled');
	&menu_button('','Set enabled status for relay','setup12');
	print '</td><td>';
	if (@g > 1)
	{
	    print popup_menu(-name=>'rname',-values=>[(@g)],-class=>'textfield',-default=>'');
	}
	else
	{
	    print hidden(-name=>'rname',-value=>$g[0],-force=>'1');
	    print xss($g[0]);
	}
	print '</td><th align=center> to </th><td>';
	print popup_menu(-name=>'status',-values=>[('Yes','No')],-class=>'textfield');
	print '</th></tr>';
    }
    print end_form;
    print start_form(-class=>'form',-name=>'wait_relay');
    if ($rig->list_devices('relay'))
    {
	my @g = $rig->list_devices('relay');
	print '<tr><td>';
	&print_hidden_rig();
	&action('wait_input');
	&menu_button('','Wait for input from relay','setup1');
	print '</td><td>';
	if (@g > 1)
	{
	    unshift @g,'';
	    print popup_menu(-name=>'rname',-values=>[(@g)],-class=>'textfield',-default=>'');
	}
	else
	{
	    print hidden(-name=>'rname',-value=>$g[0],-force=>'1');
	    print xss($g[0]);
	}
	print '</td><th align=center> Maximum time (minutes) </th><td>';
	print textfield(-name=>'maxtime',-value=>'',-force=>'1',-class=>'textfield');
	print '</th></tr>';
    }
    print end_form;    
    if (&get_cv('global','allow_exec') && @list)
    {
	my $path = $RFC::Header::libdir.'user_exec/';
	opendir DIR,$path or die &errorlog("Could not open dir $path: $!");
	my @list = grep {!/^\./} readdir DIR; ## Only read real files and not . or ..
	closedir DIR;
	print start_form(-class=>'form',-name=>'exec');
	print '<tr><td>';
	&print_hidden_rig();
	&action('exec');
	&menu_button('','Execute external program:','s3');
	print '</td><th>';
	if (@list > 1)
	{
	    print popup_menu(-name=>'program',-values=>[(@list)],-class=>'textfield',-default=>'');
	}
	else
	{
	    print hidden(-name=>'program',-value=>$list[0],-force=>'1');
	    print xss($list[0]);
	}
	print '</td><th> Arguments: </th><td colspan=4>';
	print textfield(-name=>'args',-value=>'',-force=>'1',-class=>'textfield');
	print '</td></tr>';
	print end_form;
    }    

    print start_form(-class=>'form');
    print '<tr><td>';
    &print_hidden_rig();
    &action('text');
    &menu_button('','Add text:','s3');
    print '</td><td colspan=6>';
    print textfield(-name=>'text',-value=>'',-force=>'1',-class=>'textfield');
    print '</td></tr>';
    print end_form;
    print '</table>';
    print '</td></tr>';
    print '</table>';

}    



sub clear_prog()
{
    eval
    {
	$file->lock_ex;
	$file->open_write;
	$file->close;
	$file->lock_un;
    };
    if ($@)
    {
	&errorlog($@);
	&print_error();
    }
    &main_page();
}

sub add_cmd()
{
    my $cmd = shift;
    chomp $cmd;
    eval
    {
	$file->append($cmd);
    };
    if ($@)
    {
	&errorlog($@);
	&print_error();
    }
}

sub dellast
{
    eval 
    {
	my @l = ();
	@l = $file->readlines() if (-e $file->filename);
	pop @l if (@l);
	$file->writeline(@l);
    };
    if ($@)
    {
	&errorlog($@);
	&print_error();
    }
}

sub imp
{
    my $mode = shift;
    my $ip = &get_CGI_value('ip');
    my $port = &get_CGI_value_clean('port');
    my $addr = 0;
    my $file = &get_CGI_value('comp');
    my $user = &get_CGI_value_clean('riguser');
    my $session = &get_CGI_value_clean('session');
    if ($ip && $ip =~ /([\d\.]*)/)
    {
	$ip = $1;
    }
    if ($file && $file =~ /([\w\.\/]*)/)
    {
	$file = $1;
    }
    $rig->change_config_value('impedance','server',$ip);
    $rig->change_config_value('impedance','port',$port);
    $rig->change_config_value('impedance','user',$user);
    $rig->change_config_value('impedance','session',$session);
    $rig->change_config_value('impedance','compensation',$file);
    my $dir = $publicdir.'rig'.$rig->name.'/imp_comp/';
    $dir = $comploc if ($comploc);
    if ($mode)
    {
	if ($rig->list_devices_control('PSU'))
	{
	    &add_cmd("measure");
	    &add_cmd("current = OCV");
	    &add_cmd("wait = 1");
	}
	&add_cmd("measure");
	&add_cmd("wait = 1");
	&add_cmd("impedance $ip:$port $session $user comp:$dir$file");
    }
    else
    {
	$dir = '' if ($file =~ /DEFAULT/);
	&add_cmd("#STDIMP IP:$ip PORT:$port USER:$user SESSION:$session BOX:$addr COMP:$dir$file");
    }
}

sub socket_call
{
    my $ip = &get_CGI_value('ip');
    my $port = &get_CGI_value_clean('port');
    if ($ip && $ip =~ /([\d\.]+)/)
    {
	$ip = $1;
	$rig->change_config_value('impedance','server',$ip);
    }
    $rig->change_config_value('impedance','port',$port);
    my $argstr = &get_CGI_value('args');
    $argstr = '' unless (defined($argstr));
    my @args = split(/\s*\,\s*/,$argstr);
    &add_cmd("socket $ip:$port ".join("\t",@args));
}

sub cimp
{
    my $ip = &get_CGI_value('ip');
    my $port = &get_CGI_value_clean('port');
    my $user = &get_CGI_value_clean('riguser');
    my $session = &get_CGI_value_clean('session');
    if ($ip && $ip =~ /([\d\.]*)/)
    {
	$ip = $1;
    }
    $rig->change_config_value('impedance','server',$ip);
    $rig->change_config_value('impedance','port',$port);
    $rig->change_config_value('impedance','user',$user);
    $rig->change_config_value('impedance','session',$session);
    &add_cmd("measure");
    if (@_)
    {
	my $cmd = shift;
	&add_cmd("$cmd $ip:$port $session $user comp:");
    }
    else
    {
	&add_cmd("current_impedance $ip:$port $session $user comp:");
    }
}


sub multiplex
{
    my $cn = &get_CGI_value_clean('controler');
    my $gas = &get_CGI_value_clean('gas');
    my $flow = &get_CGI_value_clean('flow');
    &add_cmd("gas_multiplexer $cn $gas");
    &add_cmd("gas:$gas = $flow");
}
