#!/usr/bin/perl -T
# $Id: task.cgi,v 1.3 2016/06/17 12:33:01 sqko Exp $
############################################################
############################################################
###                                                      ###
###   Originally designed by Soeren Koch                 ###
###                                                      ###
###   Impelemented by Soeren Koch                        ###
###                                                      ###
###   Copyright by Soeren Koch January 2015              ###
###                                                      ###
############################################################
############################################################
#$ENV{'PATH'} = '/bin:/usr/bin:/usr/local/bin';
use strict;
use warnings;
use CGI qw(:standard :netscape);
use RFC::Main;
use RFC::RFCCGI qw(:cgi :html);
use RFC::Header;

my $acmode = get_cv('global','access_mode');
$acmode = 'celltest' unless ($acmode);
my @list = ($acmode);

my $id = get_CGI_value_clean('task');
my $admin = 0;
my $cert = 0;
my $uid = &login_ok();
$| = 1;

if (!defined(param))
{
    &print_header("Welcome to the user manager for the $name");
    print '<center>';
    RFC::RFCCGI::login();
    print '</center>';
    &print_end;
}
else
{
    if ($uid)
    { 
	$admin = &is_admin();
        print_header("$name safety clearance management page");
        print RFC_start_html(-title=>"$name safety clearance management page", -style=>{src=>'/celltest/RFCcontrol.css'});
        param(-name=>'action',-value=>'')  unless (defined(param('action')));
	top_nav_bar_start();
	top_no_button;
	top_no_button;
	top_no_button;
	tab_newrow();
	js_back();
	top_js_return('#006600','white');
	top_no_button;
	top_no_button;
	top_no_button;
	top_nav_bar_button('main.cgi','','','To menu','s4');
	end_top_bar;
	$_ = param('action');
      CASE:
	{
	    /Change name/ and do {&RFC::RFCCGI::passwd_client('task_name',get_id(),get_CGI_value_clean('task'),param('task_name')); &main_page(); last CASE;};
	    /Set status/ and do {&set_valid(); &main_page(); last CASE;};
	    /Set certification/ and do {&RFC::RFCCGI::passwd_client('set_task_cert',get_id(),param('avail'),get_CGI_value_clean('task')); &main_page(); last CASE;};
	    /Set authorisation/ and do {&RFC::RFCCGI::passwd_client('set_task_auth',get_id(),param('avail'),get_CGI_value_clean('task')); &main_page(); last CASE;};
	    /Revoke certification/ and do {&RFC::RFCCGI::passwd_client('rev_task_cert',get_id(),param('users'),get_CGI_value_clean('task')); &main_page(); last CASE;};
	    /Revoke authorisation/ and do {&RFC::RFCCGI::passwd_client('rev_task_auth',get_id(),param('users'),get_CGI_value_clean('task')); &main_page(); last CASE;};
	    /Create new task/ and do {&new_task(); &main_page(); last CASE;};
	    ### Default response ###
	    &main_page();
	}
	&print_end;
    }
    else
    {
	&not_auth;
    }
}


sub new_task()
{
    my $taskname = param('task_name');
    return unless ($admin);
    $id = &RFC::RFCCGI::passwd_client('new_task',$taskname);
}

sub set_valid()
{
    my $status = get_CGI_value_clean('valid');
    $status = 0 unless ($status);
    &RFC::RFCCGI::passwd_client('task_valid',get_id(),$id,$status);
}

sub main_page()
{
    my $str = &RFC::RFCCGI::passwd_client('get_task_names',get_id());
    my @list = ('');
    my %keys = (''=>'');
    if ($str && $str =~ /\w/)
    {
	foreach my $item (split(/\n/,$str))
	{
	    my ($id,$name) = split(/\t/,$item);
	    push @list,$id;
	    $keys{$id} = $name;
	}
    }
    print '<center>';
    print h2('Curent safety clearances');
    print start_form(-name=>'task_select');
    &print_hidden();
    print popup_menu(-name=>'task',-values=>[@list],-default=>$id,-labels=>\%keys,-onchange=>'document.task_select.submit()');
    print end_form();
    if ($id)
    {
	my @users = split(/\n/,&RFC::RFCCGI::passwd_client('get_users',get_id()));
	$cert = &RFC::RFCCGI::passwd_client('check_task_cert',get_user(),$id);
	print h3('Details:');
	print '<table width=60%><tr>';
	print '<td width=20%></td>';
	print '<td width=15%></td>';
	print '<td width=15%></td>';
	print '<td width=15%></td>';
	print '<td width=15%></td>';
	print '<td width=20%></td></tr>';
	print '<tr><th> ID </th><th colspan=4>';
	print $id;
	print '</th></tr>';
	my $name = &RFC::RFCCGI::passwd_client('task_name',get_id(),$id);
	my $valid = &RFC::RFCCGI::passwd_client('task_valid',get_id(),$id);
	if ($admin)
	{
	    print start_form();
	    &print_hidden();
	    print hidden(-name=>'task',-value=>$id,-force=>1);
	    print '<tr><th> Name </th><td colspan=4>';
	    print textfield(-name=>'task_name',-value=>$name,-force=>1,-class=>'textfield');
	    print '</td><td>';
	    print submit(-name=>'action',-value=>'Change name',-class=>'s1');
	    print '</td></tr>';
	    print end_form();
	    print start_form();
	    &print_hidden();
	    print hidden(-name=>'task',-value=>$id,-force=>1);
	    print '<tr><th> Valid </th><td>';
	    print checkbox(-name=>'valid',-value=>'1',-label=>'',-checked=>$valid,-force=>1,-class=>'textfield');
	    print '</td><td>';
	    print submit(-name=>'action',-value=>'Set status',-class=>'s1');
	    print '</td></tr>';
	    print end_form();
	    my $str = &RFC::RFCCGI::passwd_client('list_cert',get_id(),$id);
	    my @cert = ();
	    @cert = split(/\n/,$str) if ($str && $str =~ /\w/);
	    print start_form();
	    &print_hidden();
	    print hidden(-name=>'task',-value=>$id,-force=>1);
	    print '<tr><th colspan=4> Certified users: </th></tr>';
	    print '<tr><th> Current users </th><td>';
	    print popup_menu(-name=>'users',-values=>['',@cert],-default=>'',force=>1,-class=>'textfield');
	    print '</td><td>';
	    print submit(-name=>'action',-value=>'Revoke certification',-class=>'s1');
	    print '</td><th> Users avaliable </th><td>';
	    my @list = ();
	  USER:
	    foreach my $u (@users)
	    {
		foreach my $c (@cert)
		{
		    next USER if ($c eq $u);
		}
		push @list,$u;
	    }
	    print popup_menu(-name=>'avail',-values=>['',@list],-default=>'',-force=>1,-class=>'textfield');
	    print '</td><td>';
	    print submit(-name=>'action',-value=>'Set certification',-class=>'s3');
	    print '</td></tr>';
	    print end_form();
	}
	else
	{
	    print '<tr><th> Name </th><th colspan=4>',$name,'</th></tr>';
	    print '<tr><th> Valid </th><th>';
	    if ($valid)
	    {
		print 'Yes';
	    }
	    else
	    {
		print 'No';
	    }
	    print '</th></tr>';
	}
	if ($valid && ($cert || $admin))
	{
	    my @auth = ();
	    my $str = &RFC::RFCCGI::passwd_client('list_auth',get_id(),$id);
	    @auth = split(/\n/,$str) if ($str && $str =~ /\w/);
	    print start_form();
	    &print_hidden();
	    print hidden(-name=>'task',-value=>$id,-force=>1);
	    print '<tr><th colspan=4> Authorised users: </th></tr>';
	    print '<tr><th> Current users </th><td>';
	    print popup_menu(-name=>'users',-values=>['',@auth],-default=>'',-force=>1,-class=>'textfield');
	    print '</td><td>';
	    print submit(-name=>'action',-value=>'Revoke authorisation',-class=>'s1');
	    print '</td><th> Users avaliable </th><td>';
	    @list = ();
	  USER:
	    foreach my $u (@users)
	    {
		foreach my $c (@auth)
		{
		    next USER if ($c eq $u);
		}
		push @list,$u;
	    }
	    print popup_menu(-name=>'avail',-values=>['',@list],-default=>'',-force=>1,-class=>'textfield');
	    print '</td><td>';
	    print submit(-name=>'action',-value=>'Set authorisation',-class=>'s3');
	    print '</td></tr>';
	    print end_form();
	}
	if ($admin)
	{
	    print '<tr><td height=50></td></tr>';
	    print start_form(-name=>'new_task',-onsubmit=>'return checknew()');
	    print_hidden();
	    print '<tr><th colspan=2>Create new task </th><th>Name:</th><td colspan=2>';
	    print textfield(-name=>'task_name',-value=>'',-force=>1,-class=>'textfield');
	    print '</td><td>';
	    print submit(-name=>'action',-value=>'Create new task',-class=>'s0');
	    print '</td></tr>';
	    print end_form();
	}
	print '</table>';
	print end_form();
    }
    print '</center>';
    print <<END

<script>

function checknew()
{
    if (confirm("Create new task"))
    {
	var n = document.new_task.task_name.value;
	if (n != null && n != '')
	{
	    return true;
	}
	else
	{
	    alert('No name for the new task was specified!');
	}
    }
    return false;
}

</script>

END

}
